Index: issm/trunk/src/m/classes/surfaceload.m
===================================================================
--- issm/trunk/src/m/classes/surfaceload.m	(revision 25994)
+++ issm/trunk/src/m/classes/surfaceload.m	(revision 26744)
@@ -8,5 +8,5 @@
 		icethicknesschange     = [];
 		waterheightchange      = [];
-		other                  = [];
+		otherchange            = [];
 	end
 	methods
@@ -20,13 +20,13 @@
 		end % }}}
 		function self = setdefaultparameters(self) % {{{
-		
+
 			icethicknesschange=[];
 			waterheightchange=[];
-			other=[];
-		
+			otherchange=[];
+
 		end % }}}
-			function md = checkconsistency(self,md,solution,analyses) % {{{
+		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			if ~ismember('SealevelriseAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslr==0), 
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslc==0), 
 				return; 
 			end
@@ -43,5 +43,5 @@
 				md = checkfield(md,'fieldname','solidearth.surfaceload.waterheightchange','timeseries',1,'NaN',1,'Inf',1);
 			end
-			if ~isempty(self.other),
+			if ~isempty(self.otherchange),
 				md = checkfield(md,'fieldname','solidearth.surfaceload.other','timeseries',1,'NaN',1,'Inf',1);
 			end
@@ -61,30 +61,95 @@
 			fielddisplay(self,'icethicknesschange','thickness change: ice height equivalent [mIce/yr]');
 			fielddisplay(self,'waterheightchange','water height change: water height equivalent [mWater/yr]');
-			fielddisplay(self,'other','other loads (sediments) [kg/m^2/yr]');
+			fielddisplay(self,'otherchange','other loads (sediments) [kg/m^2/yr]');
 
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
 
+			%deal with ice thickness change: {{{
 			if isempty(self.icethicknesschange),
 				self.icethicknesschange=zeros(md.mesh.numberofelements+1,1);
 			end
+
+			yts=md.constants.yts;
+
+			if isa(self.icethicknesschange,'cell'),
+				%transform our cell array of time series into cell array of time series of rates 
+				nummodels=length(self.icethicknesschange);
+				for i=1:nummodels,
+					icethicknesschange=self.icethicknesschange{i}; 
+					time=icethicknesschange(end,:);
+					dt=diff(time,1,2);
+					icethicknesschange_rate=diff(icethicknesschange(1:end-1,:),1,2)./dt;
+					self.icethicknesschange{i}=icethicknesschange_rate; 
+				end
+				WriteData(fid,prefix,'object',self,'fieldname','icethicknesschange','name','md.solidearth.surfaceload.icethicknesschange',...
+				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',yts,'scale',1/yts);
+			else
+				icethicknesschange=self.icethicknesschange;
+				time=icethicknesschange(end,:);
+				dt=diff(time,1,2);
+				icethicknesschange_rate=diff(icethicknesschange(1:end-1,:),1,2)./dt;
+				self.icethicknesschange=icethicknesschange_rate; 
+
+				WriteData(fid,prefix,'object',self,'fieldname','icethicknesschange','name','md.solidearth.surfaceload.icethicknesschange',...
+				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',yts,'scale',1/yts);
+			end
+			%}}}
+			%deal with water height change: {{{
 			if isempty(self.waterheightchange),
 				self.waterheightchange=zeros(md.mesh.numberofelements+1,1);
 			end
-			if isempty(self.other),
-				self.other=zeros(md.mesh.numberofelements+1,1);
+
+			if isa(self.waterheightchange,'cell'),
+				%transform our cell array of time series into cell array of time series of rates 
+				nummodels=length(self.waterheightchange);
+				for i=1:nummodels,
+					waterheightchange=self.waterheightchange{i}; 
+					time=waterheightchange(end,:);
+					dt=diff(time,1,2);
+					waterheightchange_rate=diff(waterheightchange(1:end-1,:),1,2)./dt;
+					self.waterheightchange{i}=waterheightchange_rate; 
+				end
+				WriteData(fid,prefix,'object',self,'fieldname','waterheightchange','name','md.solidearth.surfaceload.waterheightchange',...
+				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',yts,'scale',1/yts);
+			else
+				waterheightchange=self.waterheightchange;
+				time=waterheightchange(end,:);
+				dt=diff(time,1,2);
+				waterheightchange_rate=diff(waterheightchange(1:end-1,:),1,2)./dt;
+				self.waterheightchange=waterheightchange_rate; 
+
+				WriteData(fid,prefix,'object',self,'fieldname','waterheightchange','name','md.solidearth.surfaceload.waterheightchange',...
+				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',yts,'scale',1/yts);
 			end
-			if isa(self.icethicknesschange,'cell'),
-				WriteData(fid,prefix,'object',self,'fieldname','icethicknesschange','name','md.solidearth.surfaceload.icethicknesschange',...
-				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
-			else
-				WriteData(fid,prefix,'object',self,'fieldname','icethicknesschange','name','md.solidearth.surfaceload.icethicknesschange',...
-				'format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			%}}}
+			%deal with other: {{{
+			if isempty(self.otherchange),
+				self.otherchange=zeros(md.mesh.numberofelements+1,1);
 			end
 
-			WriteData(fid,prefix,'object',self,'fieldname','waterheightchange','name','md.solidearth.surfaceload.waterheightchange',...
-				'format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',self,'fieldname','other','name','md.solidearth.surfaceload.other',...
-				'format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			if isa(self.otherchange,'cell'),
+				%transform our cell array of time series into cell array of time series of rates 
+				nummodels=length(self.otherchange);
+				for i=1:nummodels,
+					otherchange=self.otherchange{i}; 
+					time=otherchange(end,:);
+					dt=diff(time,1,2);
+					otherchange_rate=diff(otherchange(1:end-1,:),1,2)./dt;
+					self.otherchange{i}=otherchange_rate; 
+				end
+				WriteData(fid,prefix,'object',self,'fieldname','otherchange','name','md.solidearth.surfaceload.otherchange',...
+				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',yts,'scale',1/yts);
+			else
+				otherchange=self.otherchange;
+				time=otherchange(end,:);
+				dt=diff(time,1,2);
+				otherchange_rate=diff(otherchange(1:end-1,:),1,2)./dt;
+				self.otherchange=otherchange_rate; 
+
+				WriteData(fid,prefix,'object',self,'fieldname','otherchange','name','md.solidearth.surfaceload.otherchange',...
+				'format','MatArray','timeserieslength',md.mesh.numberofelements+1,'yts',yts,'scale',1/yts);
+			end
+			%}}}
 
 		end % }}}
@@ -93,5 +158,5 @@
 			writejs1Darray(fid,[modelname '.surfaceload.icethicknesschange'],self.icethicknesschange);
 			writejs1Darray(fid,[modelname '.surfaceload.waterheightchange'],self.waterheightchange);
-			writejs1Darray(fid,[modelname '.surfaceload.other'],self.other);
+			writejs1Darray(fid,[modelname '.surfaceload.otherchange'],self.otherchange);
 		end % }}}
 		function self = extrude(self,md) % {{{
Index: issm/trunk/src/m/classes/surfaceload.py
===================================================================
--- issm/trunk/src/m/classes/surfaceload.py	(revision 25994)
+++ issm/trunk/src/m/classes/surfaceload.py	(revision 26744)
@@ -13,9 +13,9 @@
     """
 
-    def __init__(self, *args): #{{{
-        self.icethicknesschange = []
-        self.waterheightchange  = []
-        self.other              = []
-        
+    def __init__(self, *args):  #{{{
+        self.icethicknesschange = np.nan
+        self.waterheightchange = np.nan
+        self.other = np.nan
+
         nargin = len(args)
 
@@ -26,5 +26,5 @@
     #}}}
 
-    def __repr__(self): # {{{
+    def __repr__(self):  #{{{
         s = '   surfaceload:\n'
         s += '{}\n'.format(fielddisplay(self, 'icethicknesschange', 'thickness change: ice height equivalent [mIce/yr]'))
@@ -34,33 +34,48 @@
     #}}}
 
-    def setdefaultparameters(self): # {{{
+    def setdefaultparameters(self):  # {{{
         return self
     #}}}
 
-    def checkconsistency(self, md, solution, analyses): # {{{
-        if ('SealevelriseAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslr):
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if ('SealevelchangeAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslc):
             return md
-        if len(self.icethicknesschange):
-            md  = checkfield(md,'fieldname', 'solidearth.surfaceload.icethicknesschange', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
-        if len(self.waterheightchange):
-            md  = checkfield(md,'fieldname', 'solidearth.surfaceload.waterheightchange', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
-        if len(self.other):
-            md  = checkfield(md,'fieldname', 'solidearth.surfaceload.other', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
+        if type(self.icethicknesschange) == np.ndarray:
+            md = checkfield(md, 'fieldname', 'solidearth.surfaceload.icethicknesschange', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
+        if type(self.waterheightchange) == np.ndarray:
+            md = checkfield(md, 'fieldname', 'solidearth.surfaceload.waterheightchange', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
+        if type(self.other) == np.ndarray:
+            md = checkfield(md, 'fieldname', 'solidearth.surfaceload.other', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
         return md
     #}}}
 
-    def marshall(self, prefix, md, fid): #{{{
-        if len(self.icethicknesschange) == 0:
+    def marshall(self, prefix, md, fid):  #{{{
+        # TODO
+        # - When surfaceload class is used eventually, check premarshall 
+        # modifications against those done in MATLAB
+        #
+
+        # Deal with ice thickness change
+        if np.isempty(self.icethicknesschange):
             self.icethicknesschange = np.zeros((md.mesh.numberofelements + 1, ))
-        if len(self.waterheightchange) == 0:
+
+        yts = md.constants.yts
+
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'icethicknesschange', 'name', 'md.solidearth.surfaceload.icethicknesschange', 'format', 'MatArray', 'timeserieslength', md.mesh.numberofelements + 1, 'yts', yts, 'scale', 1 / yts)
+
+        # Deal with ice thickness change
+        if np.isempty(self.waterheightchange):
             self.waterheightchange = np.zeros((md.mesh.numberofelements + 1, ))
-        if len(self.other) == 0:
-            self.other = np.zeros((md.mesh.numberofelements + 1, ))
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'icethicknesschange', 'name', 'md.solidearth.surfaceload.icethicknesschange', 'format', 'DoubleMat', 'mattype', 2, 'timeserieslength', md.mesh.numberofelements + 1, 'yts', md.constants.yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'waterheightchange', 'name', 'md.solidearth.surfaceload.waterheightchange', 'format', 'DoubleMat', 'mattype', 2, 'timeserieslength', md.mesh.numberofelements + 1, 'yts', md.constants.yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'other', 'name', 'md.solidearth.surfaceload.other', 'format', 'DoubleMat', 'mattype', 2, 'timeserieslength', md.mesh.numberofelements + 1, 'yts', md.constants.yts)
+
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'waterheightchange', 'name', 'md.solidearth.surfaceload.waterheightchange', 'format', 'MatArray', 'timeserieslength', md.mesh.numberofelements + 1, 'yts', yts, 'scale', 1 / yts)
+
+        # Deal with ice thickness change
+        if np.isempty(self.otherchange):
+            self.otherchange = np.zeros((md.mesh.numberofelements + 1, ))
+
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'otherchange', 'name', 'md.solidearth.surfaceload.otherchange', 'format', 'MatArray', 'timeserieslength', md.mesh.numberofelements + 1, 'yts', yts, 'scale', 1 / yts)
     #}}}
 
-    def extrude(self, md): #{{{
+    def extrude(self, md):  #{{{
         return self
     #}}}
Index: issm/trunk/src/m/classes/taoinversion.m
===================================================================
--- issm/trunk/src/m/classes/taoinversion.m	(revision 25994)
+++ issm/trunk/src/m/classes/taoinversion.m	(revision 26744)
@@ -114,6 +114,6 @@
 			md = checkfield(md,'fieldname','inversion.cost_functions','size',[1 num_costfunc],'values',supportedcostfunctions());
 			md = checkfield(md,'fieldname','inversion.cost_functions_coefficients','size',[md.mesh.numberofvertices num_costfunc],'>=',0);
-			md = checkfield(md,'fieldname','inversion.min_parameters','size',[md.mesh.numberofvertices num_controls]);
-			md = checkfield(md,'fieldname','inversion.max_parameters','size',[md.mesh.numberofvertices num_controls]);
+			md = checkfield(md,'fieldname','inversion.min_parameters','size',[NaN num_controls]);
+			md = checkfield(md,'fieldname','inversion.max_parameters','size',[NaN num_controls]);
 
 			if strcmp(solution,'BalancethicknessSolution')
Index: issm/trunk/src/m/classes/timestepping.js
===================================================================
--- issm/trunk/src/m/classes/timestepping.js	(revision 25994)
+++ issm/trunk/src/m/classes/timestepping.js	(revision 26744)
@@ -6,5 +6,5 @@
 function timestepping (){
 	//methods
-	this.setdefaultparameters = function(){// {{{
+	this.setdefaultparameters = function(){ //{{{
 		//time between 2 time steps
 		this.time_step=1./2.;
@@ -14,7 +14,8 @@
 
 		//should we interpolate forcings between timesteps?
-		this.interp_forcings=1;
-	}// }}}
-	this.disp= function(){// {{{
+		this.interp_forcing=1;
+		this.cycle_forcing=0;
+	} //}}}
+	this.disp= function(){ //{{{
 
 		var unit;
@@ -24,12 +25,13 @@
 		fielddisplay(this,'final_time','final time to stop the simulation ['+ unit + ']');
 		fielddisplay(this,'time_step','length of time steps [' +unit+ ']');
-		fielddisplay(this,'interp_forcings','interpolate in time between requested forcing values ? (0 or 1)');
+		fielddisplay(this,'interp_forcing','interpolate in time between requested forcing values ? (0 or 1)');
+		fielddisplay(this,'cycle_forcing','cycle through forcing ? (0 or 1)');
 		fielddisplay(this,'coupling_time','length of coupling time steps with ocean model [' +unit+ ']');
 
-	}// }}}
-	this.classname= function(){// {{{
+	} //}}}
+	this.classname= function(){ //{{{
 		return "timestepping";
 
-	}// }}}
+	} //}}}
 	this.checkconsistency = function(md,solution,analyses) { //{{{
 
@@ -37,8 +39,12 @@
 		checkfield(md,'fieldname','timestepping.final_time','numel',[1],'NaN',1,'Inf',1);
 		checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>=',0,'NaN',1,'Inf',1);
-		checkfield(md,'fieldname','timestepping.interp_forcings','numel',[1],'values',[0,1]);
+		checkfield(md,'fieldname','timestepping.interp_forcing','numel',[1],'values',[0,1]);
+		checkfield(md,'fieldname','timestepping.cycle_forcing','numel',[1],'values',[0,1]);
 		checkfield(md,'fieldname','timestepping.coupling_time','numel',[1],'>=',0,'NaN',1,'Inf',1);
 		if (this.final_time-this.start_time<0){
 			md.checkmessage('timestepping.final_time should be larger than timestepping.start_time');
+		}
+		if (solution=='TransientSolution'){
+			checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>',0,'NaN',1,'Inf',1);
 		}
 	} // }}}
@@ -52,5 +58,6 @@
 		WriteData(fid,prefix,'object',this,'fieldname','final_time','format','Double','scale',scale);
 		WriteData(fid,prefix,'object',this,'fieldname','time_step','format','Double','scale',scale);
-		WriteData(fid,prefix,'object',this,'fieldname','interp_forcings','format','Boolean');
+		WriteData(fid,prefix,'object',this,'fieldname','interp_forcing','format','Boolean');
+		WriteData(fid,prefix,'object',this,'fieldname','cycle_forcing','format','Boolean');
 		WriteData(fid,prefix,'object',this,'fieldname','coupling_time','format','Double','scale',scale);
 
@@ -63,5 +70,6 @@
 	this.final_time      = 0.;
 	this.time_step       = 0.;
-	this.interp_forcings = 1;
+	this.interp_forcing  = 1;
+	this.cycle_forcing   = 1;
 	this.coupling_time   = 0.;
 
Index: issm/trunk/src/m/classes/timestepping.m
===================================================================
--- issm/trunk/src/m/classes/timestepping.m	(revision 25994)
+++ issm/trunk/src/m/classes/timestepping.m	(revision 26744)
@@ -9,5 +9,6 @@
 		final_time      = 0.;
 		time_step       = 0.;
-		interp_forcings = 1;
+		interp_forcing  = 1;
+		cycle_forcing   = 0;
 		coupling_time   = 0.;
 	end
@@ -23,4 +24,16 @@
 			end
 		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   timestepping parameters:'));
+
+			unit = 'yr';
+			fielddisplay(self,'start_time',['simulation starting time [' unit ']']);
+			fielddisplay(self,'final_time',['final time to stop the simulation [' unit ']']);
+			fielddisplay(self,'time_step',['length of time steps [' unit ']']);
+			fielddisplay(self,'interp_forcing','interpolate in time between requested forcing values? (0 or 1)');
+			fielddisplay(self,'cycle_forcing','cycle through forcing? (0 or 1)');
+			fielddisplay(self,'coupling_time',['length of coupling time step with ocean model [' unit ']']);
+
+		end % }}}
 		function self = setdefaultparameters(self) % {{{
 
@@ -31,6 +44,7 @@
 			self.final_time=10.*self.time_step;
 
-			%should we interpolate forcings between timesteps?
-			self.interp_forcings=1;
+			%should we interpolate forcing between timesteps?
+			self.interp_forcing=1;
+			self.cycle_forcing=0;
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -39,5 +53,6 @@
 			md = checkfield(md,'fieldname','timestepping.final_time','numel',[1],'NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>=',0,'NaN',1,'Inf',1);
-			md = checkfield(md,'fieldname','timestepping.interp_forcings','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','timestepping.interp_forcing','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','timestepping.cycle_forcing','numel',[1],'values',[0 1]);
 			if self.final_time-self.start_time<0,
 				md = checkmessage(md,'timestepping.final_time should be larger than timestepping.start_time');
@@ -45,17 +60,5 @@
 			if strcmp(solution,'TransientSolution'),
 				md = checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>',0,'NaN',1,'Inf',1);
-				md = checkfield(md,'fieldname','timestepping.time_step','numel',[1],'>=',0,'NaN',1,'Inf',1);
 			end
-		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   timestepping parameters:'));
-
-			unit = 'yr';
-			fielddisplay(self,'start_time',['simulation starting time [' unit ']']);
-			fielddisplay(self,'final_time',['final time to stop the simulation [' unit ']']);
-			fielddisplay(self,'time_step',['length of time steps [' unit ']']);
-			fielddisplay(self,'interp_forcings','interpolate in time between requested forcing values ? (0 or 1)');
-			fielddisplay(self,'coupling_time',['length of coupling time step with ocean model  [' unit ']']);
-
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -66,5 +69,6 @@
 			WriteData(fid,prefix,'object',self,'fieldname','final_time','format','Double','scale',scale);
 			WriteData(fid,prefix,'object',self,'fieldname','time_step','format','Double','scale',scale);
-			WriteData(fid,prefix,'object',self,'fieldname','interp_forcings','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','interp_forcing','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','cycle_forcing','format','Boolean');
 			WriteData(fid,prefix,'object',self,'fieldname','coupling_time','format','Double','scale',scale);
 		end % }}}
@@ -74,5 +78,6 @@
 			writejsdouble(fid,[modelname '.timestepping.final_time'],self.final_time);
 			writejsdouble(fid,[modelname '.timestepping.time_step'],self.time_step);
-			writejsdouble(fid,[modelname '.timestepping.interp_forcings'],self.interp_forcings);
+			writejsdouble(fid,[modelname '.timestepping.interp_forcing'],self.interp_forcing);
+			writejsdouble(fid,[modelname '.timestepping.cycle_forcing'],self.cycle_forcing);
 
 		end % }}}
Index: issm/trunk/src/m/classes/timestepping.py
===================================================================
--- issm/trunk/src/m/classes/timestepping.py	(revision 25994)
+++ issm/trunk/src/m/classes/timestepping.py	(revision 26744)
@@ -5,65 +5,67 @@
 
 class timestepping(object):
-    """
-    TIMESTEPPING Class definition
+    """TIMESTEPPING Class definition
 
-       Usage:
-          timestepping = timestepping()
+    Usage:
+        timestepping = timestepping()
     """
 
-    def __init__(self):  # {{{
-        self.start_time = 0.
-        self.final_time = 0.
-        self.time_step = 0.
-        self.interp_forcings = 1
-        self.coupling_time = 0.
+    def __init__(self, *args): #{{{
+        self.start_time = 0
+        self.final_time = 0
+        self.time_step = 0
+        self.interp_forcing = 1
+        self.cycle_forcing = 0
+        self.coupling_time = 0
 
-    #set defaults
-        self.setdefaultparameters()
+        if len(args) == 0:
+            self.setdefaultparameters()
+        else:
+            raise RuntimeError('constructor not supported')
+    #}}}
+    def __repr__(self): #{{{
+        s = '   timestepping parameters:\n'
+        unit = 'yr'
+        s += '{}\n'.format(fielddisplay(self, 'start_time', 'simulation starting time [' + unit + ']'))
+        s += '{}\n'.format(fielddisplay(self, 'final_time', 'final time to stop the simulation [' + unit + ']'))
+        s += '{}\n'.format(fielddisplay(self, 'time_step', 'length of time steps [' + unit + ']'))
+        s += '{}\n'.format(fielddisplay(self, 'interp_forcing', 'interpolate in time between requested forcing values? (0 or 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'cycle_forcing', 'cycle through forcing? (0 or 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'coupling_time', 'length of coupling time steps with ocean model [' + unit + ']'))
+        return s
+    #}}}
+    def setdefaultparameters(self): #{{{
+        # Time between 2 time steps
+        self.time_step = 1 / 2
 
-    #}}}
+        # Final time
+        self.final_time = 10 * self.time_step
 
-    def __repr__(self):  # {{{
-        string = "   timestepping parameters:"
-        string = "%s\n%s" % (string, fielddisplay(self, "start_time", "simulation starting time [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "final_time", "final time to stop the simulation [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "time_step", "length of time steps [yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "interp_forcings", "interpolate in time between requested forcing values ? (0 or 1)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "coupling_time", "length of coupling time steps with ocean model [yr]"))
-        return string
-    #}}}
-
-    def setdefaultparameters(self):  # {{{
-        #time between 2 time steps
-        self.time_step = 1. / 2.
-        #final time
-        self.final_time = 10. * self.time_step
-        #should we interpolate forcings between timesteps?
-        self.interp_forcings = 1
+        # Should we interpolate forcing between timesteps?
+        self.interp_forcing = 1
+        self.cycle_forcing = 0
 
         return self
     #}}}
-
-    def checkconsistency(self, md, solution, analyses):  # {{{
-
+    def checkconsistency(self, md, solution, analyses): #{{{
         md = checkfield(md, 'fieldname', 'timestepping.start_time', 'numel', [1], 'NaN', 1, 'Inf', 1)
         md = checkfield(md, 'fieldname', 'timestepping.final_time', 'numel', [1], 'NaN', 1, 'Inf', 1)
         md = checkfield(md, 'fieldname', 'timestepping.time_step', 'numel', [1], '>=', 0, 'NaN', 1, 'Inf', 1)
-        if self.final_time - self.start_time < 0:
-            md.checkmessage("timestepping.final_time should be larger than timestepping.start_time")
-            md = checkfield(md, 'fieldname', 'timestepping.coupling_time', 'numel', [1], '>=', 0, 'NaN', 1, 'Inf', 1)
-        md = checkfield(md, 'fieldname', 'timestepping.interp_forcings', 'numel', [1], 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'timestepping.cycle_forcing', 'numel', [1], 'values', [0, 1])
+        if (self.final_time - self.start_time) < 0:
+            md.checkmessage('timestepping.final_time should be larger than timestepping.start_time')
+        if solution == 'TransientSolution':
+            md = checkfield(md, 'fieldname', 'timestepping.time_step', 'numel', [1], '>', 0, 'NaN', 1, 'Inf', 1)
 
         return md
-    # }}}
-
-    def marshall(self, prefix, md, fid):  # {{{
-
-        yts = md.constants.yts
+    #}}}
+    def marshall(self, prefix, md, fid): #{{{
+        scale = md.constants.yts
         WriteData(fid, prefix, 'name', 'md.timestepping.type', 'data', 1, 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'start_time', 'format', 'Double', 'scale', yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'final_time', 'format', 'Double', 'scale', yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'time_step', 'format', 'Double', 'scale', yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'interp_forcings', 'format', 'Boolean')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'coupling_time', 'format', 'Double', 'scale', yts)
-    # }}}
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'start_time', 'format', 'Double', 'scale', scale)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'final_time', 'format', 'Double', 'scale', scale)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'time_step', 'format', 'Double', 'scale', scale)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'interp_forcing', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'cycle_forcing', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'coupling_time', 'format', 'Double', 'scale', scale)
+    #}}}
Index: issm/trunk/src/m/classes/timesteppingadaptive.js
===================================================================
--- issm/trunk/src/m/classes/timesteppingadaptive.js	(revision 25994)
+++ issm/trunk/src/m/classes/timesteppingadaptive.js	(revision 26744)
@@ -19,4 +19,5 @@
 		//should we interpolate forcings between timesteps?
 		this.interp_forcings=1;
+		this.cycle_forcing=0;
 	}// }}}
 	this.disp= function(){// {{{
@@ -31,4 +32,5 @@
 		fielddisplay(this,'cfl_coefficient','coefficient applied to cfl condition');
 		fielddisplay(this,'interp_forcings','interpolate in time between requested forcing values ? (0 or 1)');
+		fielddisplay(this,'cycle_forcing','cycle through forcing ? (0 or 1)');
 		fielddisplay(this,'coupling_time','coupling time steps with ocean model [' +unit+ ']');
 
@@ -46,4 +48,5 @@
 		checkfield(md,'fieldname','timestepping.cfl_coefficient','numel',[1],'>',0,'<=',1);
 		checkfield(md,'fieldname','timestepping.interp_forcings','numel',[1],'values',[0,1]);
+		checkfield(md,'fieldname','timestepping.cycle_forcing','numel',[1],'values',[0,1]);
 		if (this.final_time-this.start_time<0){
 			md.checkmessage('timestepping.final_time should be larger than timestepping.start_time');
@@ -63,4 +66,5 @@
 		WriteData(fid,prefix,'object',this,'class','timestepping','fieldname','cfl_coefficient','format','Double');
 		WriteData(fid,prefix,'object',this,'class','timestepping','fieldname','interp_forcings','format','Boolean');
+		WriteData(fid,prefix,'object',this,'class','timestepping','fieldname','cycle_forcing','format','Boolean');
 		WriteData(fid,prefix,'object',this,'class','timestepping','fieldname','coupling_time','format','Double','scale',scale);
 
@@ -76,4 +80,5 @@
 	this.cfl_coefficient = 0.;
 	this.interp_forcings = 1;
+	this.cycle_forcing   = 0;
 	this.coupling_time   = 0.;
 
Index: issm/trunk/src/m/classes/timesteppingadaptive.m
===================================================================
--- issm/trunk/src/m/classes/timesteppingadaptive.m	(revision 25994)
+++ issm/trunk/src/m/classes/timesteppingadaptive.m	(revision 26744)
@@ -11,5 +11,6 @@
 		time_step_max   = 0.;
 		cfl_coefficient = 0.;
-		interp_forcings = 1;
+		interp_forcing = 1;
+		cycle_forcing = 1;
 		coupling_time   = 0.;
 	end
@@ -37,6 +38,7 @@
 			self.cfl_coefficient=0.5;
 
-			%should we interpolate forcings between timesteps?
-			self.interp_forcings=1;
+			%should we interpolate forcing between timesteps?
+			self.interp_forcing=1;
+			self.cycle_forcing=0;
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -47,5 +49,6 @@
 			md = checkfield(md,'fieldname','timestepping.time_step_max','numel',[1],'>=',md.timestepping.time_step_min,'NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','timestepping.cfl_coefficient','numel',[1],'>',0,'<=',1);
-			md = checkfield(md,'fieldname','timestepping.interp_forcings','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','timestepping.interp_forcing','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','timestepping.cycle_forcing','numel',[1],'values',[0 1]);
 			md = checkfield(md,'fieldname','timestepping.coupling_time','numel',[1],'>=',md.timestepping.coupling_time,'NaN',1,'Inf',1);
 			if self.final_time-self.start_time<0,
@@ -62,5 +65,6 @@
 			fielddisplay(self,'time_step_max',['maximum length of time step [' unit ']']);
 			fielddisplay(self,'cfl_coefficient','coefficient applied to cfl condition');
-			fielddisplay(self,'interp_forcings','interpolate in time between requested forcing values ? (0 or 1)');
+			fielddisplay(self,'interp_forcing','interpolate in time between requested forcing values ? (0 or 1)');
+			fielddisplay(self,'cycle_forcing','cycle through forcing ? (0 or 1)');
 			fielddisplay(self,'coupling_time',['coupling time step with ocean model [' unit ']']);
 
@@ -75,5 +79,6 @@
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','time_step_max','format','Double','scale',scale);
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','cfl_coefficient','format','Double');
-			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','interp_forcings','format','Boolean');
+			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','interp_forcing','format','Boolean');
+			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','cycle_forcing','format','Boolean');
 			WriteData(fid,prefix,'object',self,'class','timestepping','fieldname','coupling_time','format','Double','scale',scale);
 		end % }}}
@@ -85,5 +90,6 @@
 			writejsdouble(fid,[modelname '.timesteppingadaptive.time_step_max'],self.time_step_max);
 			writejsdouble(fid,[modelname '.timesteppingadaptive.cfl_coefficient'],self.cfl_coefficient);
-			writejsdouble(fid,[modelname '.timesteppingadaptive.interp_forcings'],self.interp_forcings);
+			writejsdouble(fid,[modelname '.timesteppingadaptive.interp_forcing'],self.interp_forcing);
+			writejsdouble(fid,[modelname '.timesteppingadaptive.cycle_forcing'],self.cycle_forcing);
 			writejsdouble(fid,[modelname '.timesteppingadaptive.coupling_time'],self.time_step_max);
 
